# coding: utf-8

"""
    SaaSus ApiLog API Schema

    SaaSus ApiLog API Schema

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from datetime import date, datetime

from pydantic import Field, StrictStr

from typing import Optional

from saasus_sdk_python.src.apilog.models.api_log import ApiLog
from saasus_sdk_python.src.apilog.models.api_logs import ApiLogs

from saasus_sdk_python.src.apilog.api_client import ApiClient
from saasus_sdk_python.src.apilog.api_response import ApiResponse
from saasus_sdk_python.src.apilog.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ApiLogApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def get_log(self, api_log_id : Annotated[StrictStr, Field(..., description="API Log ID")], **kwargs) -> ApiLog:  # noqa: E501
        """Get API execution log  # noqa: E501

        Retrieve the log of the API execution with the specified ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_log(api_log_id, async_req=True)
        >>> result = thread.get()

        :param api_log_id: API Log ID (required)
        :type api_log_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ApiLog
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the get_log_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.get_log_with_http_info(api_log_id, **kwargs)  # noqa: E501

    @validate_arguments
    def get_log_with_http_info(self, api_log_id : Annotated[StrictStr, Field(..., description="API Log ID")], **kwargs) -> ApiResponse:  # noqa: E501
        """Get API execution log  # noqa: E501

        Retrieve the log of the API execution with the specified ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_log_with_http_info(api_log_id, async_req=True)
        >>> result = thread.get()

        :param api_log_id: API Log ID (required)
        :type api_log_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ApiLog, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'api_log_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_log" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['api_log_id']:
            _path_params['api_log_id'] = _params['api_log_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Bearer']  # noqa: E501

        _response_types_map = {
            '200': "ApiLog",
            '500': "Error",
        }

        return self.api_client.call_api(
            '/logs/{api_log_id}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_logs(self, created_date : Annotated[Optional[date], Field(description="The date, in format of YYYY-MM-DD, to retrieve the log.")] = None, created_at : Annotated[Optional[datetime], Field(description="The datetime, in ISO 8601 format, to retrieve the log.")] = None, limit : Annotated[Optional[Annotated[int, Field(strict=True, ge=1)]], Field(description="Maximum number of logs to retrieve.")] = None, cursor : Annotated[Optional[StrictStr], Field(description="Cursor for cursor pagination.")] = None, **kwargs) -> ApiLogs:  # noqa: E501
        """Get API execution log list  # noqa: E501

        Retrieve the log of all API executions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_logs(created_date, created_at, limit, cursor, async_req=True)
        >>> result = thread.get()

        :param created_date: The date, in format of YYYY-MM-DD, to retrieve the log.
        :type created_date: date
        :param created_at: The datetime, in ISO 8601 format, to retrieve the log.
        :type created_at: datetime
        :param limit: Maximum number of logs to retrieve.
        :type limit: int
        :param cursor: Cursor for cursor pagination.
        :type cursor: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ApiLogs
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the get_logs_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.get_logs_with_http_info(created_date, created_at, limit, cursor, **kwargs)  # noqa: E501

    @validate_arguments
    def get_logs_with_http_info(self, created_date : Annotated[Optional[date], Field(description="The date, in format of YYYY-MM-DD, to retrieve the log.")] = None, created_at : Annotated[Optional[datetime], Field(description="The datetime, in ISO 8601 format, to retrieve the log.")] = None, limit : Annotated[Optional[Annotated[int, Field(strict=True, ge=1)]], Field(description="Maximum number of logs to retrieve.")] = None, cursor : Annotated[Optional[StrictStr], Field(description="Cursor for cursor pagination.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Get API execution log list  # noqa: E501

        Retrieve the log of all API executions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_logs_with_http_info(created_date, created_at, limit, cursor, async_req=True)
        >>> result = thread.get()

        :param created_date: The date, in format of YYYY-MM-DD, to retrieve the log.
        :type created_date: date
        :param created_at: The datetime, in ISO 8601 format, to retrieve the log.
        :type created_at: datetime
        :param limit: Maximum number of logs to retrieve.
        :type limit: int
        :param cursor: Cursor for cursor pagination.
        :type cursor: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ApiLogs, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'created_date',
            'created_at',
            'limit',
            'cursor'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logs" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('created_date') is not None:  # noqa: E501
            if isinstance(_params['created_date'], date):
                _query_params.append(('created_date', _params['created_date'].strftime(self.api_client.configuration.date_format)))
            else:
                _query_params.append(('created_date', _params['created_date']))

        if _params.get('created_at') is not None:  # noqa: E501
            if isinstance(_params['created_at'], datetime):
                _query_params.append(('created_at', _params['created_at'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('created_at', _params['created_at']))

        if _params.get('limit') is not None:  # noqa: E501
            _query_params.append(('limit', _params['limit']))

        if _params.get('cursor') is not None:  # noqa: E501
            _query_params.append(('cursor', _params['cursor']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Bearer']  # noqa: E501

        _response_types_map = {
            '200': "ApiLogs",
            '500': "Error",
        }

        return self.api_client.call_api(
            '/logs', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
