# coding: utf-8

"""
    SaaSus Auth API Schema

    Schema

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import field_validator, ConfigDict, BaseModel, Field, StrictStr

class AccountVerification(BaseModel):
    """
    Account authentication settings ※ This function is not yet provided, so it cannot be changed or saved. 
    """
    verification_method: StrictStr = Field(..., description="code: verification code link: verification link ※ This function is not yet provided, so it cannot be changed or saved. ")
    sending_to: StrictStr = Field(..., description="email: e-mail sms: SMS smsOrEmail: email if SMS is not possible ")
    __properties = ["verification_method", "sending_to"]

    @field_validator('verification_method')
    @classmethod
    def verification_method_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('code', 'link'):
            raise ValueError("must be one of enum values ('code', 'link')")
        return value

    @field_validator('sending_to')
    @classmethod
    def sending_to_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('email', 'sms', 'smsOrEmail'):
            raise ValueError("must be one of enum values ('email', 'sms', 'smsOrEmail')")
        return value
    model_config = ConfigDict(populate_by_name=True, validate_assignment=True)

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AccountVerification:
        """Create an instance of AccountVerification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AccountVerification:
        """Create an instance of AccountVerification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AccountVerification.parse_obj(obj)

        _obj = AccountVerification.parse_obj({
            "verification_method": obj.get("verification_method"),
            "sending_to": obj.get("sending_to")
        })
        return _obj


