# coding: utf-8

"""
    SaaSus Auth API Schema

    Schema

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import ConfigDict, BaseModel, Field, StrictBool, StrictInt

class PasswordPolicy(BaseModel):
    """
    Password Policy
    """
    minimum_length: StrictInt = Field(..., description="Minimum number of characters")
    is_require_lowercase: StrictBool = Field(..., description="Contains one or more lowercase characters")
    is_require_numbers: StrictBool = Field(..., description="Contains one or more numeric characters")
    is_require_symbols: StrictBool = Field(..., description="Contains one or more special characters")
    is_require_uppercase: StrictBool = Field(..., description="Contains one or more uppercase letters")
    temporary_password_validity_days: StrictInt = Field(..., description="Temporary password expiration date")
    __properties = ["minimum_length", "is_require_lowercase", "is_require_numbers", "is_require_symbols", "is_require_uppercase", "temporary_password_validity_days"]
    model_config = ConfigDict(populate_by_name=True, validate_assignment=True)

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PasswordPolicy:
        """Create an instance of PasswordPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PasswordPolicy:
        """Create an instance of PasswordPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PasswordPolicy.parse_obj(obj)

        _obj = PasswordPolicy.parse_obj({
            "minimum_length": obj.get("minimum_length"),
            "is_require_lowercase": obj.get("is_require_lowercase"),
            "is_require_numbers": obj.get("is_require_numbers"),
            "is_require_symbols": obj.get("is_require_symbols"),
            "is_require_uppercase": obj.get("is_require_uppercase"),
            "temporary_password_validity_days": obj.get("temporary_password_validity_days")
        })
        return _obj


