# coding: utf-8

"""
    SaaSus Pricing API Schema

    SaaSus Pricing API Schema

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Literal, Any, List, Optional
from pydantic import field_validator, ConfigDict, BaseModel, StrictStr, ValidationError
from saasus_sdk_python.src.pricing.models.pricing_fixed_unit import PricingFixedUnit
from saasus_sdk_python.src.pricing.models.pricing_tiered_unit import PricingTieredUnit
from saasus_sdk_python.src.pricing.models.pricing_tiered_usage_unit import PricingTieredUsageUnit
from saasus_sdk_python.src.pricing.models.pricing_usage_unit import PricingUsageUnit
from typing import Union, Any, List, TYPE_CHECKING, Dict
from pydantic import StrictStr

PRICINGUNIT_ONE_OF_SCHEMAS = ["PricingFixedUnit", "PricingTieredUnit", "PricingTieredUsageUnit", "PricingUsageUnit"]

class PricingUnit(BaseModel):
    """
    PricingUnit
    """
    # data type: PricingTieredUsageUnit
    oneof_schema_1_validator: Optional[PricingTieredUsageUnit] = None
    # data type: PricingTieredUnit
    oneof_schema_2_validator: Optional[PricingTieredUnit] = None
    # data type: PricingUsageUnit
    oneof_schema_3_validator: Optional[PricingUsageUnit] = None
    # data type: PricingFixedUnit
    oneof_schema_4_validator: Optional[PricingFixedUnit] = None
    if TYPE_CHECKING:
        actual_instance: Union[PricingFixedUnit, PricingTieredUnit, PricingTieredUsageUnit, PricingUsageUnit]
    else:
        actual_instance: Any = None
    one_of_schemas: Literal[PRICINGUNIT_ONE_OF_SCHEMAS] = PRICINGUNIT_ONE_OF_SCHEMAS
    model_config = ConfigDict(validate_assignment=True)

    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    @classmethod
    def actual_instance_must_validate_oneof(cls, v):
        instance = PricingUnit.construct()
        error_messages = []
        match = 0
        # validate data type: PricingTieredUsageUnit
        if not isinstance(v, PricingTieredUsageUnit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PricingTieredUsageUnit`")
        else:
            match += 1
        # validate data type: PricingTieredUnit
        if not isinstance(v, PricingTieredUnit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PricingTieredUnit`")
        else:
            match += 1
        # validate data type: PricingUsageUnit
        if not isinstance(v, PricingUsageUnit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PricingUsageUnit`")
        else:
            match += 1
        # validate data type: PricingFixedUnit
        if not isinstance(v, PricingFixedUnit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PricingFixedUnit`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PricingUnit with oneOf schemas: PricingFixedUnit, PricingTieredUnit, PricingTieredUsageUnit, PricingUsageUnit. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PricingUnit with oneOf schemas: PricingFixedUnit, PricingTieredUnit, PricingTieredUsageUnit, PricingUsageUnit. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> PricingUnit:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> PricingUnit:
        """Returns the object represented by the json string"""
        instance = PricingUnit.construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `PricingFixedUnit`
        if _data_type == "PricingFixedUnit":
            instance.actual_instance = PricingFixedUnit.from_json(json_str)
            return instance

        # check if data type is `PricingTieredUnit`
        if _data_type == "PricingTieredUnit":
            instance.actual_instance = PricingTieredUnit.from_json(json_str)
            return instance

        # check if data type is `PricingTieredUsageUnit`
        if _data_type == "PricingTieredUsageUnit":
            instance.actual_instance = PricingTieredUsageUnit.from_json(json_str)
            return instance

        # check if data type is `PricingUsageUnit`
        if _data_type == "PricingUsageUnit":
            instance.actual_instance = PricingUsageUnit.from_json(json_str)
            return instance

        # check if data type is `PricingFixedUnit`
        if _data_type == "fixed":
            instance.actual_instance = PricingFixedUnit.from_json(json_str)
            return instance

        # check if data type is `PricingTieredUnit`
        if _data_type == "tiered":
            instance.actual_instance = PricingTieredUnit.from_json(json_str)
            return instance

        # check if data type is `PricingTieredUsageUnit`
        if _data_type == "tiered_usage":
            instance.actual_instance = PricingTieredUsageUnit.from_json(json_str)
            return instance

        # check if data type is `PricingUsageUnit`
        if _data_type == "usage":
            instance.actual_instance = PricingUsageUnit.from_json(json_str)
            return instance

        # deserialize data into PricingTieredUsageUnit
        try:
            instance.actual_instance = PricingTieredUsageUnit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PricingTieredUnit
        try:
            instance.actual_instance = PricingTieredUnit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PricingUsageUnit
        try:
            instance.actual_instance = PricingUsageUnit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PricingFixedUnit
        try:
            instance.actual_instance = PricingFixedUnit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PricingUnit with oneOf schemas: PricingFixedUnit, PricingTieredUnit, PricingTieredUsageUnit, PricingUsageUnit. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PricingUnit with oneOf schemas: PricingFixedUnit, PricingTieredUnit, PricingTieredUsageUnit, PricingUsageUnit. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


